-- ../migrations/0001-initial.sql
CREATE TABLE wines (
	wine_id integer primary key not null,
	name text not null,
	rating int,   -- number of stars
	picture blob, -- jpeg/png image of the label on the bottle
	country text  -- ISO2 country code
);

CREATE TABLE comments (
	comment_id integer primary key not null,
	wine_id integer not null,
	content text not null,

	foreign key (wine_id) references wines (wine_id)
);

CREATE TABLE state (
	key text not null,
	val text not null,

	unique(key)
);

CREATE TABLE users (
	userID integer primary key not null,
	name text not null,
	password text not null, -- salted and hashed

	unique(name)
);

CREATE TABLE sessions (
	userID int not null,    -- User this session is valid for
	token text not null,    -- Text of session token, to be stored in user cookiejar
	created time not null,  -- Creation time of the session
	remote string not null, -- remote address that created the session

	foreign key (userID) references users (userID)
);

CREATE TABLE IF NOT EXISTS migrations (
	name text not null,
	unique(text)
);