{{ template "base" . }}

{{ define "title" }}User{{ end }}

{{ define "header-left" }}
	<a class="pure-button" href="/"><i class="fas fa-arrow-left"></i> Back</a>
{{ end }}

{{ define "content" }}
{{ template "header" . }}

<div class="content withfooter user pure-u-1">
	<div class="maxwidth box">
		<div class="pure-menu pure-menu-horizontal">
			<ul class="pure-menu-list">
				<li class="pure-menu-item {{ if eq .Page "you" -}} pure-menu-selected {{- end }}">
					<a href="you" class="pure-menu-link">You</a>
				</li>
				<li class="pure-menu-item {{ if eq .Page "all-users" -}} pure-menu-selected {{- end }}">
					<a href="all-users" class="pure-menu-link">All users</a>
				</li>
				<li class="pure-menu-item {{ if eq .Page "sessions" -}} pure-menu-selected {{- end }}">
					<a href="sessions" class="pure-menu-link">Sessions</a>
				</li>
			</ul>
		</div>

		{{ if eq .Page "you" }}
			<form class="pure-form pure-form-aligned" method="POST">
				<fieldset>
					<div class="pure-control-group">
						<label for="form-old-pw">Current Password</label>
						<input type="password" id="form-old-pw" name="old-pw" required>
						{{ if .FormErrors.OldPW }}
							<span class="errmsg pure-form-message-inline">{{ .FormErrors.OldPW }}</span>
						{{ end }}
					</div>

					<div class="pure-control-group">
						<label for="form-new-pw-1">New Password</label>
						<input type="password" id="form-new-pw-1" name="new-pw" required>
						{{ if .FormErrors.NewPW }}
							<span class="errmsg pure-form-message-inline">{{ .FormErrors.NewPW }}</span>
						{{ end }}
					</div>

					<div class="pure-control-group">
						<label for="form-new-pw-2">New Password (repeat)</label>
						<input type="password" id="form-new-pw-2" name="new-pw-repeat" required>
					</div>
				</fieldset>

				<button type="submit" class="pure-button pure-button-primary" name="action" value="update">
					<i class="fas fa-save"></i>
					Update password
				</button>
			</form>

			{{ if .ShowResult }}
				{{ if .Success }}
					<p>Updated \o/
				{{ else }}
					<p class="errmsg">Something went wrong.
				{{ end }}
			{{ end }}
		{{ end }}

		{{ if eq .Page "all-users" }}
			{{ if .GeneratedPassword }}
			<p>User created, generated password: <code>{{ .GeneratedPassword }}</code>
			{{ end }}

			<form class="pure-form pure-form-aligned" method="POST">
				<div class="pure-control-group">
					<label for="form-new-user">New user name</label>
					<input type="text" id="form-new-user" name="new-user" required>
					{{ if .FormErrors.NewUser }}
						<span class="errmsg pure-form-message-inline">{{ .FormErrors.NewUser }}</span>
					{{ end }}
				</div>

				<button type="submit" class="pure-button pure-button-primary" name="action" value="create">
					<i class="fas fa-plus"></i>
					Create user
				</button>
			</form>

			{{ if .AllUsers }}
			<hr/>

			<h2>All users</h2>

			{{ if .FormErrors.DeleteUser }}
				<span class="errmsg">{{ .FormErrors.DeleteUser }}</span>
			{{ end }}

			<table class="pure-table">
				<thead><tr><th>Name</th><th></th></tr></thead>
				<tbody>
					{{ range .AllUsers }}
					<tr>
						<td>{{ . }}</td>
						<td><form method="POST">
							<input type="hidden" name="username" value="{{ . }}">
							<button type="submit" class="pure-button button-warning" name="action" value="delete">
								<i class="fas fa-trash-alt"></i>
							</button>
						</form></td>
					</tr>
					{{ end }}
				</tbody>
			</table>
			{{ end }}
		{{ end }}

		{{ if eq .Page "sessions" }}
			<h2>All sessions</h2>

			<table class="pure-table">
				<thead><tr><th>Name</th><th>Session created</th><th>Original IP</th></tr></thead>
				<tbody>
					{{ range .AllSessions }}
					<tr>
						<td>{{ .Name }}</td>
						<td>{{ .Created }}</td>
						<td>{{ .Remote }}</td>
					</tr>
					{{ end }}
				</tbody>
			</table>
		{{ end }}
	</div>
</div>

<footer class="small pure-u-1">
	<div class="maxwidth box">
		<form class="pure-form" method="POST">
			<button type="submit" class="right pure-button button-warning" name="action" value="logout">
				<i class="fas fa-sign-out-alt"></i>
				Log out
			</button>
		</form>
	</div>
</footer>
{{ end }}